diff a/test/langtools/tools/javac/reflect/ReflectableLambdaTest.java b/test/langtools/tools/javac/reflect/ReflectableLambdaTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/reflect/ReflectableLambdaTest.java
@@ -0,0 +1,251 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @summary Smoke test for code reflection with quotable lambdas.
+ * @modules jdk.incubator.code
+ * @build ReflectableLambdaTest
+ * @build CodeReflectionTester
+ * @run main CodeReflectionTester ReflectableLambdaTest
+ */
+
+import jdk.incubator.code.Reflect;
+import java.util.function.IntBinaryOperator;
+import java.util.function.IntFunction;
+import java.util.function.IntSupplier;
+import java.util.function.IntUnaryOperator;
+
+public class ReflectableLambdaTest {
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.lang.Runnable" = lambda @lambda.isQuotable=true ()java.type:"void" -> {
+                    return;
+                };
+                return;
+            };
+            """)
+    static final Runnable QUOTED_NO_PARAM_VOID = (@Reflect Runnable) () -> {
+    };
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.util.function.IntSupplier" = lambda @lambda.isQuotable=true ()java.type:"int" -> {
+                    %1 : java.type:"int" = constant @1;
+                    return %1;
+                };
+                return;
+            };
+            """)
+    static final IntSupplier QUOTED_NO_PARAM_CONST = (@Reflect IntSupplier) () -> 1;
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%1 : java.type:"int")java.type:"int" -> {
+                    %2 : Var<java.type:"int"> = var %1 @"x";
+                    %3 : java.type:"int" = var.load %2;
+                    return %3;
+                };
+                return;
+            };
+            """)
+    static final IntUnaryOperator QUOTED_ID = (@Reflect IntUnaryOperator) x -> x;
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.util.function.IntBinaryOperator" = lambda @lambda.isQuotable=true (%1 : java.type:"int", %2 : java.type:"int")java.type:"int" -> {
+                    %3 : Var<java.type:"int"> = var %1 @"x";
+                    %4 : Var<java.type:"int"> = var %2 @"y";
+                    %5 : java.type:"int" = var.load %3;
+                    %6 : java.type:"int" = var.load %4;
+                    %7 : java.type:"int" = add %5 %6;
+                    return %7;
+                };
+                return;
+            };
+            """)
+    static final IntBinaryOperator QUOTED_PLUS = (@Reflect IntBinaryOperator) (x, y) -> x + y;
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.lang.Runnable" = lambda @lambda.isQuotable=true ()java.type:"void" -> {
+                    %1 : java.type:"java.lang.AssertionError" = new @java.ref:"java.lang.AssertionError::()";
+                    throw %1;
+                };
+                return;
+            };
+            """)
+    static final Runnable QUOTED_THROW_NO_PARAM = (@Reflect Runnable) () -> {
+        throw new AssertionError();
+    };
+
+    @IR("""
+            func @"f" (%0 : Var<java.type:"int">)java.type:"void" -> {
+                %1 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%2 : java.type:"int")java.type:"int" -> {
+                    %3 : Var<java.type:"int"> = var %2 @"y";
+                    %4 : java.type:"int" = var.load %0;
+                    %5 : java.type:"int" = var.load %3;
+                    %6 : java.type:"int" = add %4 %5;
+                    return %6;
+                };
+                return;
+            };
+            """)
+    static final IntUnaryOperator QUOTED_CAPTURE_PARAM = new Object() {
+        IntUnaryOperator captureContext(int x) {
+            return (@Reflect IntUnaryOperator) y -> x + y;
+        }
+    }.captureContext(42);
+
+    static class Context {
+        int x, y;
+
+        IntUnaryOperator capture() {
+            return (@Reflect IntUnaryOperator) z -> x + y + z;
+        }
+    }
+
+    @IR("""
+            func @"f" (%0 : java.type:"ReflectableLambdaTest$Context")java.type:"void" -> {
+                %1 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%2 : java.type:"int")java.type:"int" -> {
+                    %3 : Var<java.type:"int"> = var %2 @"z";
+                    %4 : java.type:"int" = field.load %0 @java.ref:"ReflectableLambdaTest$Context::x:int";
+                    %5 : java.type:"int" = field.load %0 @java.ref:"ReflectableLambdaTest$Context::y:int";
+                    %6 : java.type:"int" = add %4 %5;
+                    %7 : java.type:"int" = var.load %3;
+                    %8 : java.type:"int" = add %6 %7;
+                    return %8;
+                };
+                return;
+            };
+            """)
+    static final IntUnaryOperator QUOTED_CAPTURE_FIELD = new Context().capture();
+
+    @Reflect
+    @IR("""
+            func @"captureParam" (%0 : java.type:"int")java.type:"void" -> {
+                %1 : Var<java.type:"int"> = var %0 @"x";
+                %2 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%3 : java.type:"int")java.type:"int" -> {
+                    %4 : Var<java.type:"int"> = var %3 @"y";
+                    %5 : java.type:"int" = var.load %1;
+                    %6 : java.type:"int" = var.load %4;
+                    %7 : java.type:"int" = add %5 %6;
+                    return %7;
+                };
+                %8 : Var<java.type:"java.util.function.IntUnaryOperator"> = var %2 @"op";
+                return;
+            };
+            """)
+    static void captureParam(int x) {
+        IntUnaryOperator op = (@Reflect IntUnaryOperator) y -> x + y;
+    }
+
+    int x, y;
+
+    @Reflect
+    @IR("""
+            func @"captureField" (%0 : java.type:"ReflectableLambdaTest")java.type:"void" -> {
+                %1 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%2 : java.type:"int")java.type:"int" -> {
+                    %3 : Var<java.type:"int"> = var %2 @"z";
+                    %4 : java.type:"int" = field.load %0 @java.ref:"ReflectableLambdaTest::x:int";
+                    %5 : java.type:"int" = field.load %0 @java.ref:"ReflectableLambdaTest::y:int";
+                    %6 : java.type:"int" = add %4 %5;
+                    %7 : java.type:"int" = var.load %3;
+                    %8 : java.type:"int" = add %6 %7;
+                    return %8;
+                };
+                %9 : Var<java.type:"java.util.function.IntUnaryOperator"> = var %1 @"op";
+                return;
+            };
+            """)
+    void captureField() {
+        IntUnaryOperator op = (@Reflect IntUnaryOperator) z -> x + y + z;
+    }
+
+    static void m() {
+    }
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.lang.Runnable" = lambda @lambda.isQuotable=true ()java.type:"void" -> {
+                    invoke @java.ref:"ReflectableLambdaTest::m():void";
+                    return;
+                };
+                return;
+            };
+            """)
+    static final Runnable QUOTED_NO_PARAM_VOID_REF = (@Reflect Runnable) ReflectableLambdaTest::m;
+
+    static int g(int i) {
+        return i;
+    }
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%1 : java.type:"int")java.type:"int" -> {
+                    %2 : Var<java.type:"int"> = var %1 @"x$0";
+                    %3 : java.type:"int" = var.load %2;
+                    %4 : java.type:"int" = invoke %3 @java.ref:"ReflectableLambdaTest::g(int):int";
+                    return %4;
+                };
+                return;
+            };
+            """)
+    static final IntUnaryOperator QUOTED_INT_PARAM_INT_RET_REF = (@Reflect IntUnaryOperator) ReflectableLambdaTest::g;
+
+    @IR("""
+            func @"f" ()java.type:"void" -> {
+                %0 : java.type:"java.util.function.IntFunction<int[]>" = lambda @lambda.isQuotable=true (%1 : java.type:"int")java.type:"int[]" -> {
+                    %2 : Var<java.type:"int"> = var %1 @"x$0";
+                    %3 : java.type:"int" = var.load %2;
+                    %4 : java.type:"int[]" = new %3 @java.ref:"int[]::(int)";
+                    return %4;
+                };
+                return;
+            };
+            """)
+    static final IntFunction<int[]> QUOTED_INT_PARAM_ARR_RET_REF = (@Reflect IntFunction<int[]>) int[]::new;
+
+    static class ContextRef {
+        int g(int i) {
+            return i;
+        }
+
+        IntUnaryOperator capture() {
+            return (@Reflect IntUnaryOperator) this::g;
+        }
+    }
+
+    @IR("""
+            func @"f" (%0 : java.type:"ReflectableLambdaTest$ContextRef")java.type:"void" -> {
+                %1 : java.type:"java.util.function.IntUnaryOperator" = lambda @lambda.isQuotable=true (%2 : java.type:"int")java.type:"int" -> {
+                    %3 : Var<java.type:"int"> = var %2 @"x$0";
+                    %4 : java.type:"int" = var.load %3;
+                    %5 : java.type:"int" = invoke %0 %4 @java.ref:"ReflectableLambdaTest$ContextRef::g(int):int";
+                    return %5;
+                };
+                return;
+            };
+            """)
+    static final IntUnaryOperator QUOTED_CAPTURE_THIS_REF = new ContextRef().capture();
+}